=== debian/changelog ===
open3d (0.17.0+ds-8) unstable; urgency=medium

  * Rebuild against PyTorch 2.0 and TinyGLTF 2.8.15

 -- Timo Röhling <roehling@debian.org>  Wed, 06 Sep 2023 09:19:39 +0200

open3d (0.17.0+ds-7) unstable; urgency=medium

  * Clean documentation build and __pycache__ artifacts (Closes: #1048872)

 -- Timo Röhling <roehling@debian.org>  Tue, 15 Aug 2023 22:38:37 +0200

open3d (0.17.0+ds-6) unstable; urgency=medium

  * Fix Arch: all build

 -- Timo Röhling <roehling@debian.org>  Wed, 12 Jul 2023 00:47:24 +0200

open3d (0.17.0+ds-5) unstable; urgency=medium

  * Enable PyTorch
  * Fix FTBFS with ImGui 1.89+
  * Do not install empty directories

 -- Timo Röhling <roehling@debian.org>  Tue, 11 Jul 2023 23:30:47 +0200

open3d (0.17.0+ds-4) unstable; urgency=medium

  * Fix broken nanoflann::SearchParameters for radiusSearch()

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Jun 2023 11:18:01 +0200

open3d (0.17.0+ds-3) unstable; urgency=medium

  * Fix build with nanoflann 1.5
  * Fix build with gcc-13 (Closes: #1037800)

 -- Timo Röhling <roehling@debian.org>  Mon, 19 Jun 2023 00:11:11 +0200

open3d (0.17.0+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Mon, 12 Jun 2023 14:23:10 +0200

open3d (0.17.0+ds-1) experimental; urgency=medium

  * New upstream version 0.17.0+ds
  * Refresh patches
  * Bump SONAME to 0.17
  * Update d/copyright
  * Prepare d/rules for future contrib builds with CUDA
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Sat, 27 May 2023 21:21:44 +0200
